//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
//---------------------------------------------------------------------------
#include "AppGlobalF.h"
#include "ITSDbF.h"
#include "DMDbF.h"
#include "ITSLangTransF.h"

//---------------------------------------------------------------------------
USEFORM("MAIN\FrmCameraScreenManagerF.cpp", FrmCameraScreenManager);
USEFORM("MAIN\FrmCameraInfoF.cpp", FrmCameraInfo);
USEFORM("MAIN\FrmInitializeF.cpp", FrmInitialize);
USEFORM("MAIN\FrmCameraFullScreenF.cpp", FrmCameraFullScreen);
USEFORM("MAIN\FrmCameraScreenF.cpp", FrmCameraScreen);
USEFORM("MAIN\FrmVmsCamViewerF.cpp", FrmVmsCamViewer);
USEFORM("..\COMMON\DM\DMDbF.cpp", DMDb); /* TDataModule: File Type */
USEFORM("MAIN\FrmCameraPlayerF.cpp", FrmCameraPlayer);
USEFORM("MAIN\FRAME\FRAME_ObjListF.cpp", FRAMEObjList); /* TFrame: File Type */
//---------------------------------------------------------------------------
WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR, int)
{
    int nLoginRes;

    DateSeparator = '-';
    TimeSeparator = ':';
    ShortDateFormat ="yyyy-MM-dd";
    ShortTimeFormat = "hh:nn:ss";
    LongTimeFormat  = "hh:nn:ss";


    String sLoginId = "ADMIN";
    bool bLogin = true;
    int nArgs = ParamCount();
    if (nArgs >= 1)
    {
        sLoginId = ParamStr(1);
        bLogin = false;
    }

    int nRes;
    g_nPid     = (int)GetCurrentProcessId();
    g_sAppDir  = ExtractFilePath(Application->ExeName);
    g_sAppName = ChangeFileExt(ExtractFileName(Application->ExeName), "");
    g_sCfgDir  = g_sAppDir + "Cfg\\";
    g_sLogDir  = g_sAppDir + "Log\\";
    g_sTempDir = g_sAppDir + "Temp\\";
    g_sFormsDir = g_sCfgDir + "Forms\\";

    ForceDirectories(g_sCfgDir.c_str());
    ForceDirectories(g_sLogDir.c_str());
    ForceDirectories(g_sTempDir.c_str());
    ForceDirectories(g_sFormsDir.c_str());
    String sTempDir = g_sLogDir + "Db\\";
    ForceDirectories(sTempDir.c_str());

    String sAppDir = ExtractFilePath(Application->ExeName);
    ChDir(sAppDir);

    /*
    *  시스템 운영환경을 ini 파일에서 읽어 온다.
    */
    LoadDefaultConfigInfo("ITS_OP");

    g_sLangDir = g_sAppDir + "Lang\\";
    g_sLangDir = g_sLangDir + g_AppCfg.sLang + "\\";
    ForceDirectories(g_sLangDir.c_str());

    LangTrans = new TLangTrans("VmsCamViewer", g_AppCfg.sLang, g_sLangDir, true);

    ITSLog = new TITSLog(g_sLogDir, g_sAppName, g_AppCfg.sLogDay);
    ITSLog->FLogCfg = g_LogCfg;

    try
    {
        ReportMemoryLeaksOnShutdown = true;
        Application->Initialize();
        Application->MainFormOnTaskBar = true;
        Application->Title = g_AppCfg.sTitle;
        Application->Title = "VMS 영상 모니터링";
         Application->CreateForm(__classid(TFrmVmsCamViewer), &FrmVmsCamViewer);
         Application->CreateForm(__classid(TDMDb), &DMDb);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    catch (...)
    {
         try
         {
             throw Exception("");
         }
         catch (Exception &exception)
         {
             Application->ShowException(&exception);
         }
    }

prog_exit:
    try
    {
    }
    catch(...)
    {
    }
    
    return 0;
}
//---------------------------------------------------------------------------

